Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet.jsp.el
Class ExpressionEvaluator

    java.lang.Object
      javax.servlet.jsp.el.ExpressionEvaluator

    public abstract class ExpressionEvaluator

extends Object

The abstract base class for an expression-language evaluator. Classes that implement an expression language expose their functionality via this abstract class.

An instance of the ExpressionEvaluator can be obtained via the JspContext / PageContext

The parseExpression() and evaluate() methods must be thread-safe. That is, multiple threads may call these methods on the same ExpressionEvaluator object simultaneously. Implementations should synchronize access if they depend on transient state. Implementations should not, however, assume that only one object of each ExpressionEvaluator type will be instantiated; global caching should therefore be static.

Only a single EL expression, starting with '${' and ending with '}', can be parsed or evaluated at a time. EL expressions cannot be mixed with static text. For example, attempting to parse or evaluate "`abc${1+1}def${1+1}ghi`" or even "`${1+1}${1+1}`" will cause an `ELException` to be thrown.

The following are examples of syntactically legal EL expressions:

- `${person.lastName}`
- `${8 * 8}`
- `${my:reverse('hello')}`

Since:
  2.0

Constructor Summary
`ExpressionEvaluator()`

Method Summary
`abstract Object` | `evaluate(String expression, Class expectedType, VariableResolver vResolver, FunctionMapper fMapper)` Evaluates an expression.
`abstract Expression` | `parseExpression(String expression, Class expectedType, FunctionMapper fMapper)` Prepare an expression for later evaluation.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ExpressionEvaluator

    public ExpressionEvaluator()

Method Detail

### parseExpression

    public abstract Expression parseExpression(String expression,
                                               Class expectedType,
                                               FunctionMapper fMapper)
                                        throws ELException

  Prepare an expression for later evaluation. This method should perform syntactic validation of the expression; if in doing so it detects errors, it should raise an ELParseException.

  Parameters:
    `expression` - The expression to be evaluated.
    `expectedType` - The expected type of the result of the evaluation
    `fMapper` - A FunctionMapper to resolve functions found in the expression. It can be null, in which case no functions are supported for this invocation. The ExpressionEvaluator must not hold on to the FunctionMapper reference after returning from `parseExpression()`. The `Expression` object returned must invoke the same functions regardless of whether the mappings in the provided `FunctionMapper` instance change between calling `ExpressionEvaluator.parseExpression()` and `Expression.evaluate()`.
  Returns:
    The Expression object encapsulating the arguments.
  Throws:
    `ELException` - Thrown if parsing errors were found.

### evaluate

    public abstract Object evaluate(String expression,
                                    Class expectedType,
                                    VariableResolver vResolver,
                                    FunctionMapper fMapper)
                             throws ELException

  Evaluates an expression. This method may perform some syntactic validation and, if so, it should raise an ELParseException error if it encounters syntactic errors. EL evaluation errors should cause an ELException to be raised.

  Parameters:
    `expression` - The expression to be evaluated.
    `expectedType` - The expected type of the result of the evaluation
    `vResolver` - A VariableResolver instance that can be used at runtime to resolve the name of implicit objects into Objects.
    `fMapper` - A FunctionMapper to resolve functions found in the expression. It can be null, in which case no functions are supported for this invocation.
  Returns:
    The result of the expression evaluation.
  Throws:
    `ELException` - Thrown if the expression evaluation failed.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.